/**
 * Copyright 2009 Pierrick HYMBERT.
 * Les sources qui constituent ce projet, HyPik-Soma-Cube, 
 * de mme que la documentation associe sont la proprit
 * de leur auteur.
 * Je donne mon accord au site developpez.com pour l'utili-
 * sation de tout ou partie des sources et de la documenta-
 * tion de ce projet dans les pages developpez.com
 */
package fr.hypik.developpez.defis.soma.core.engine.impl;

import java.util.List;

import org.apache.log4j.Logger;

import fr.hypik.developpez.defis.soma.core.exception.PuzzleInvalideException;
import fr.hypik.developpez.defis.soma.core.model.Cube;
import fr.hypik.developpez.defis.soma.core.model.Piece;

/**
 * Un moteur qui n'utilise pas de structure complexe, mais seulement des tableaux de boolens.
 * 
 * Non terminee :P
 * 
 * @author Pierrick HYMBERT
 *
 */
//TODO: Implmenter le moteur rapide
public class SpeedySomaEngine extends AbstractSomaEngine {

	/**
	 * Le logger de la classe
	 */
	private static final Logger logger = Logger
			.getLogger(SpeedySomaEngine.class);
	/**
	 * 
	 */
	public static final int ESPACE = BORNE_MAX - BORNE_MIN;
	/**
	 * L'instance de SpeedySomaEngine
	 */
	private static final SpeedySomaEngine singleton = new SpeedySomaEngine();

	/**
	 * @return L'instance de SpeedySomaEngine
	 */
	public static SpeedySomaEngine get() {
		return singleton;
	}
	
	/*
	 * (non-Javadoc)
	 * @see fr.hypik.developpez.defis.soma.core.engine.ISomaEngine#getAllSolutions(fr.hypik.developpez.defis.soma.core.model.Cube[])
	 */
	public List<Piece[]> getAllSolutions(Cube[] soma)
			throws PuzzleInvalideException {
		/*boolean[][][] puzzle = new boolean[ESPACE][ESPACE][ESPACE];
		
		boolean[][][][] pieces = new boolean[this.somaPieces.length][ESPACE][ESPACE][ESPACE];
		
		// Convertit la solution
		int[][] espace = buildPuzzleAndPiece(soma, puzzle, pieces);
		
		// Recherche toutes les solutions par pice
		boolean[][][][][] solutionsByPiece = buildSolutionsByPieces(puzzle, pieces, espace);
		*/
		return null;
	}
	
	/**
	 * Recherche toutes les solutions par pice
	 * @param puzzle
	 * @param pieces 
	 * @param maxEspace 
	 * @return
	 */
	protected boolean[][][][][] buildSolutionsByPieces(boolean[][][] puzzle, boolean[][][][] pieces, int[][] espace) {
		// calcul la distance max sur les axes de la solution
		int distanceMinX = espace[0][0];
		int distanceMinY = espace[0][1];
		int distanceMinZ = espace[0][2];
		
		int distanceMaxX = espace[1][0];
		int distanceMaxY = espace[1][1];
		int distanceMaxZ = espace[1][2];

		boolean[][][][][] solutionsByPieces = new boolean[this.somaPieces.length][200][distanceMaxX - distanceMinX + 1][distanceMaxY - distanceMinY + 1][distanceMaxZ - distanceMinZ + 1];
		
		for (int i = 0; i < this.somaPieces.length; i++) {
			buildSolutionsPiece(puzzle, solutionsByPieces[i], pieces[i], espace);
		}
		
		return solutionsByPieces;
	}
	
	/**
	 * 
	 * @param i
	 * @param puzzle
	 * @param solutionsByPieces 
	 * @param piece 
	 * @param maxEspace 
	 * @return
	 */
	private void buildSolutionsPiece(boolean[][][] puzzle, boolean[][][][] solutionsByPieces, boolean[][][] piece, int[][] espace) {
		// calcul la distance max sur les axes de la solution
		int distanceMinX = espace[0][0];
		int distanceMinY = espace[0][1];
		int distanceMinZ = espace[0][2];
		
		int distanceMaxX = espace[1][0];
		int distanceMaxY = espace[1][1];
		int distanceMaxZ = espace[1][2];

		int solutionCourante = 0;
		int sensX = 1;
		int sensY = 1;
		int sensZ = 1;
		for (int angleX = 0; angleX < 4; angleX++) {
			for (int angleY = 0; angleY < 4; angleY++) {
				for (int angleZ = 0; angleZ < 4; angleZ++) {
					for (int x = 0; x <= distanceMaxX; x++) {
						for (int y = 0; y <= distanceMaxY; y++) {
							for (int z = 0; z <= distanceMaxZ; z++) {
								// Test si la pice est incluse
								if( pieceIncluse(piece, puzzle, espace, solutionsByPieces[solutionCourante] ) )
								{
									solutionCourante++;
								}
								
								// Dplace la pice sur z
								for(int xx = distanceMinX; xx < distanceMaxX; xx++)
								{
									for(int yy = distanceMinY; yy < distanceMaxY; yy++)
									{
										boolean move = false;
										for(int zz = sensZ > 0 ? distanceMinZ : distanceMaxZ; sensZ > 0 && zz <= distanceMaxZ || sensZ < 0 && zz > distanceMinZ; zz += sensZ)
										{
											boolean value = piece[xx][yy][zz];
											piece[xx][yy][zz] = move;
											move = piece[xx][yy][zz + sensZ];
											piece[xx][yy][zz + sensZ] = value;
										}
									}
								}
							}
							sensZ = - sensZ;
							// Dplace la pice sur z
							for(int xx = distanceMinX; xx < distanceMaxX; xx++)
							{
								for(int zz = distanceMinZ; zz < distanceMaxZ; zz++)
								{
									boolean move = false;
									for(int yy = sensY > 0 ? distanceMinY : distanceMaxY; sensY > 0 && yy <= distanceMaxY || sensY < 0 && yy > distanceMinY; yy += sensY)
									{
										boolean value = piece[xx][yy][zz];
										piece[xx][yy][zz] = move;
										move = piece[xx][yy + sensY][zz];
										piece[xx][yy + sensY][zz] = value;
									}
								}
							}
						}
						sensY = - sensY;
						// Dplace la pice sur X
						for(int yy = distanceMinY; yy < distanceMaxY; yy++)
						{
							for(int zz = distanceMinZ; zz < distanceMaxZ; zz++)
							{
								boolean move = false;
								for(int xx = sensX > 0 ? distanceMinX : distanceMaxX; sensX > 0 && xx <= distanceMaxX || sensX < 0 && xx > distanceMinX; xx += sensX)
								{
									boolean value = piece[xx][yy][zz];
									piece[xx][yy][zz] = move;
									move = piece[xx + sensX][yy][zz];
									piece[xx + sensX][yy][zz] = value;
								}
							}
						}
					}
					sensX = -sensX;
				}
			}
		}
		if( logger.isDebugEnabled() )
		{
			logger.debug(solutionCourante + " solution trouves");
		}
	}
	
	/**
	 * 
	 * @param piece
	 * @param puzzle
	 * @param solutionsByPieces 
	 * @param espace2
	 * @return
	 */
	private boolean pieceIncluse(boolean[][][] piece ,boolean[][][] puzzle,
			int[][] espace, boolean[][][] solutionsByPieces) {
		int distanceMinX = espace[0][0];
		int distanceMinY = espace[0][1];
		int distanceMinZ = espace[0][2];
		
		int distanceMaxX = espace[1][0];
		int distanceMaxY = espace[1][1];
		int distanceMaxZ = espace[1][2];

		for (int x = distanceMinX; x <= distanceMaxX; x++) {
			for (int y = distanceMinY; y <= distanceMaxY; y++) {
				for (int z = distanceMinZ; z <= distanceMaxZ; z++) {
					solutionsByPieces[x - distanceMinX][y - distanceMinY][z - distanceMinZ] = piece[x][y][z];
					if( piece[x][y][z] && piece[x][y][z] != puzzle[x][y][z])
						return false;
				}
			}
		}
		return true;
	}

	/**
	 * Construit le puzzle
	 * @param soma
	 * @param puzzle 
	 * @param pieces 
	 * @return
	 */
	protected int[][] buildPuzzleAndPiece(Cube[] soma, boolean[][][] puzzle, boolean[][][][] pieces) {
		int[][] espace = new int[][]{{BORNE_MAX, BORNE_MAX, BORNE_MAX},{BORNE_MIN, BORNE_MIN, BORNE_MIN}};
		for(int x = 0; x < ESPACE; x++)
		{
			for(int y = 0; y < ESPACE; y++)
			{
				for(int z = 0; z < ESPACE; z++)
				{
					for(Cube cube : soma)
					{
						if(cube.getX() == x && cube.getY() == y && cube.getZ() == z)
						{
							puzzle[x][y][z] = true;
							espace[0][0] = Math.min(espace[0][0], x);
							espace[0][1] = Math.min(espace[0][1], y);
							espace[0][2] = Math.min(espace[0][2], z);
							espace[1][0] = Math.max(espace[1][0], x);
							espace[1][1] = Math.max(espace[1][1], y);
							espace[1][2] = Math.max(espace[1][2], z);
						}
					}
				}
			}
		}
		for(int x = 0; x < ESPACE; x++)
		{
			for(int y = 0; y < ESPACE; y++)
			{
				for(int z = 0; z < ESPACE; z++)
				{
					for (int i = 0; i < this.somaPieces.length; i++) {
						for(Cube cube : this.somaPieces[i].getCubes())
						{
							if(cube.getX() == x && cube.getY() == y && cube.getZ() == z)
							{
								pieces[i][espace[0][0] + x][espace[0][1] + y][espace[0][2] + z] = true;
							}
						}
					}
				}
			}
		}
		return espace;
	}

	public Piece[] getSolution(Cube[] soma) throws PuzzleInvalideException {
		// TODO Auto-generated method stub
		return null;
	}

}
