/**
 * Copyright 2009 Pierrick HYMBERT.
 * Les sources qui constituent ce projet, HyPik-Soma-Cube, 
 * de mme que la documentation associe sont la proprit
 * de leur auteur.
 * Je donne mon accord au site developpez.com pour l'utili-
 * sation de tout ou partie des sources et de la documenta-
 * tion de ce projet dans les pages developpez.com
 */
package fr.hypik.developpez.defis.soma.core.exception;

/**
 * Une exception leve si un fichier csv est malform
 * @author PH03599S
 *
 */
public class CsvMalformeException extends Exception {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5956355115902087569L;
	
	/**
	 * Une exception leve sur une ligne malforme
	 * @param ligne La ligne
	 * @param noLigne Le numro de la ligne malforme
	 */
	public CsvMalformeException(String ligne, int noLigne) {
		super("La ligne numro " + noLigne + " est mal forme:\n\"" + ligne + "\"");
	}
	
	/**
	 * Une exception leve sur une ligne malforme
	 * @param ligne La ligne
	 * @param noLigne Le numro de la ligne malforme
	 * @param message Un messae auxilaire
	 */
	public CsvMalformeException(String ligne, int noLigne, String message) {
		super("La ligne numro " + noLigne + " est mal forme.\n" + message + "\n\"" + ligne + "\"");
	}
}
