package fr.hypik.developpez.defis.soma.core.engine.impl;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import fr.hypik.developpez.defis.soma.core.engine.ISomaEngineTest;
import fr.hypik.developpez.defis.soma.core.exception.PuzzleInvalideException;
import fr.hypik.developpez.defis.soma.core.model.Piece;

public class EnhancedSimpleSomaEngineTest extends ISomaEngineTest {

	@Override
	protected void setEngine() {
		engine = EnhancedSimpleSomaEngine.get();
	}
	
	private EnhancedSimpleSomaEngine getEngine() {
		return (EnhancedSimpleSomaEngine) engine;
	}
	
	@Test
	public void testBuildPieceSolutionsValide1() throws PuzzleInvalideException {
		EnhancedSimpleSomaEngine.PieceSolutionProgress pieceSolutionProgress = new EnhancedSimpleSomaEngine.PieceSolutionProgress();
		List<Piece> allPieceSolutions = new ArrayList<Piece>();
		Piece solution = new Piece("Soma", valide1Cube);
		while( !pieceSolutionProgress.rechercheTerminee() )
		{
			getEngine().buildPieceSolutions(somaPieces[6], solution, allPieceSolutions, pieceSolutionProgress);
		}
	}
	
	@Test
	public void testBuildPieceSolutionsCube() throws PuzzleInvalideException {
		Piece solution = new Piece("Soma", somaCube);
		for(Piece piece : somaPieces)
		{
			List<Piece> allPieceSolutions = new ArrayList<Piece>();
			EnhancedSimpleSomaEngine.PieceSolutionProgress pieceSolutionProgress = new EnhancedSimpleSomaEngine.PieceSolutionProgress();
			while( !pieceSolutionProgress.rechercheTerminee() )
			{
				getEngine().buildPieceSolutions(piece, solution, allPieceSolutions, pieceSolutionProgress);
			}
		}
	}
}
