package fr.hypik.developpez.defis.soma.core.engine.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;

import fr.hypik.developpez.defis.soma.core.engine.ISomaEngineTest;
import fr.hypik.developpez.defis.soma.core.exception.CsvMalformeException;
import fr.hypik.developpez.defis.soma.core.exception.PuzzleInvalideException;
import fr.hypik.developpez.defis.soma.core.factory.PieceFactory;
import fr.hypik.developpez.defis.soma.core.model.Piece;

public class SimpleSomaEngineTest extends ISomaEngineTest {

	@Test
	public void testBuildAllSolutionsByPieceValide1() throws PuzzleInvalideException {
		Map<Integer, List<Piece>> allSolutionsByPiece = new HashMap<Integer, List<Piece>>();
		getEngine().buildAllSolutionsByPiece(new Piece("Soma", valide1Cube), allSolutionsByPiece);
	}
	
	@Test
	public void testBuildAllSolutionsByPieceCube() throws PuzzleInvalideException {
		Map<Integer, List<Piece>> allSolutionsByPiece = new HashMap<Integer, List<Piece>>();
		getEngine().buildAllSolutionsByPiece(new Piece("Soma", somaCube), allSolutionsByPiece);
	}

	@Test
	public void testBuildPieceSolutionsValide1() throws PuzzleInvalideException {
		getEngine().buildPieceSolutions(somaPieces[6], new Piece("Soma", valide1Cube));
	}
	
	@Test
	public void testBuildPieceSolutionsCube() throws PuzzleInvalideException, CsvMalformeException {
		getEngine().buildPieceSolutions(PieceFactory.get().loadSomaPiece("V"), new Piece("Soma", somaCube));
	}

	@Test
	public void testSetSomaPieces() {
		getEngine().setSomaPieces(somaPieces);
	}
	
	@Override
	protected void setEngine() {
		engine = SimpleSomaEngine.get();
	}
	
	private SimpleSomaEngine getEngine() {
		return (SimpleSomaEngine) engine;
	}
}
