package fr.hypik.developpez.defis.soma.core.engine.impl;

import org.junit.Before;
import org.junit.Test;

import fr.hypik.developpez.defis.soma.core.engine.ISomaEngineTest;
import fr.hypik.developpez.defis.soma.core.exception.PuzzleInvalideException;

public class SpeedySomaEngineTest extends ISomaEngineTest {
	
	private boolean[][][] puzzle;
	private boolean[][][][] pieces;
	private int[][] espace;

	@Before
	public void setUpSpeedySomaEngineTest() throws Exception {
		puzzle = new boolean[SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE];
		
		pieces = new boolean[this.somaPieces.length][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE];
		
		// Convertit la solution
		espace = getEngine()
		.buildPuzzleAndPiece(somaCube, puzzle, pieces);
		
		
	}
	
	@Test
	public void testBuildPuzzleAndPiece() throws PuzzleInvalideException {
		boolean[][][] puzzle = new boolean[SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE];
		
		boolean[][][][] pieces = new boolean[this.somaPieces.length][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE][SpeedySomaEngine.ESPACE];
		
		// Convertit la solution
		getEngine()
		.buildPuzzleAndPiece(somaCube, puzzle, pieces);
	}
	
	@Test
	public void testBuildSolutionsByPieces() throws PuzzleInvalideException {
		getEngine()
		.buildSolutionsByPieces(puzzle, pieces, espace);
	}

	@Test
	public void testSetSomaPieces() {
		getEngine().setSomaPieces(somaPieces);
	}
	
	@Override
	protected void setEngine() {
		engine = SpeedySomaEngine.get();
	}
	
	private SpeedySomaEngine getEngine() {
		return (SpeedySomaEngine) engine;
	}
}
