package fr.hypik.developpez.defis.soma.core.model;

import static org.junit.Assert.*;

import org.junit.Test;

import fr.hypik.developpez.defis.soma.core.model.Axe;
import fr.hypik.developpez.defis.soma.core.model.Cube;

public class CubeTest {

	@Test
	public void testRotation() {
		assertEquals(new Cube(0,0,1), new Cube(0,1,0).rotation(Axe.Abscisse, 1));
		assertEquals(new Cube(0,-1,0), new Cube(0,0,1).rotation(Axe.Abscisse, 1));
		assertEquals(new Cube(0,1,0), new Cube(1,0,0).rotation(Axe.Profondeur, 1));
		assertEquals(new Cube(-1,0,0), new Cube(0,1,0).rotation(Axe.Profondeur, 1));
		assertEquals(new Cube(0,10,0), new Cube(0,10,0).rotation(Axe.Profondeur, 4));
		assertEquals(new Cube(0,-1,0), new Cube(-1,0,0).rotation(Axe.Profondeur, 1));
		assertEquals(new Cube(1,-1,0), new Cube(-1,-1,0).rotation(Axe.Profondeur, 1));
	}

	@Test
	public void testDistanceCubeAxeAxe() {
		assertEquals(1, new Cube(1,0,0).distance(new Cube(0,1,0), Axe.Abscisse, Axe.Ordonnee), 0);
	}

	@Test
	public void testDistanceCubeAxe() {
		assertEquals(1, new Cube(1,0,0).distance(new Cube(0,0,0), Axe.Abscisse), 0);
	}

	@Test
	public void testDistanceCube() {
		assertEquals(0, new Cube(3,3,3).distance(new Cube(3,3,3)), 0);
		assertEquals(1, new Cube(1,0,0).distance(new Cube(0,0,0)), 0);
	}

	@Test
	public void testTranslation() {
		assertEquals(new Cube(1,0,0), new Cube(0,0,0).translation(Axe.Abscisse, 1));
		assertEquals(new Cube(0,1,0), new Cube(0,0,0).translation(Axe.Ordonnee, 1));
		assertEquals(new Cube(0,0,1), new Cube(0,0,0).translation(Axe.Profondeur, 1));
	}

}
