package fr.hypik.developpez.defis.soma.core.model;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import fr.hypik.developpez.defis.soma.core.factory.PieceFactory;
import fr.hypik.developpez.defis.soma.core.model.Axe;
import fr.hypik.developpez.defis.soma.core.model.Piece;

public class PieceTest {
	
	/**
	 * Les pieces
	 */
	private Piece[] pieces = null;
	
	/**
	 * D'autres pieces
	 */
	private Piece[] pieces2 = null;
	
	
	@Before
	public void setUp() throws Exception {
		pieces = PieceFactory.get().getAllSomaPieces();
		pieces2 = PieceFactory.get().getAllSomaPieces();
	}

	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void testRotation() {
		// S'assure que toutes les rotations fonctionnent ...
		for(int i = 0; i < pieces.length; i++)
		{
			pieces[i].rotation(Axe.Abscisse, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Abscisse, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Abscisse, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Abscisse, 1);
			assertEquals(pieces[i], pieces2[i]);
			
			pieces[i].rotation(Axe.Ordonnee, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Ordonnee, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Ordonnee, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Ordonnee, 1);
			assertEquals(pieces[i], pieces2[i]);
			
			pieces[i].rotation(Axe.Profondeur, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Profondeur, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Profondeur, 1);
			assertNotSame(pieces[i], pieces2[i]);
			pieces[i].rotation(Axe.Profondeur, 1);
			assertEquals(pieces[i], pieces2[i]);
		}
	}

	@Test
	public void testTranslation() {
		fail("Not yet implemented");
	}

	@Test
	public void testEqualsObject() {
		// S'assure que toutes les pieces sont gales ...
		for(int i = 0; i < pieces.length; i++)
		{
			assertEquals(pieces[i], pieces2[i]);
		}
	}

}
