/**
 * Copyright 2009 Pierrick HYMBERT.
 * Les sources qui constituent ce projet, HyPik-Soma-Cube, 
 * de mme que la documentation associe sont la proprit
 * de leur auteur.
 * Je donne mon accord au site developpez.com pour l'utili-
 * sation de tout ou partie des sources et de la documenta-
 * tion de ce projet dans les pages developpez.com
 */
package fr.hypik.developpez.defis.soma;

import java.io.IOException;
import java.io.OutputStream;

import org.apache.log4j.WriterAppender;
import org.eclipse.swt.widgets.Text;

/**
 * Un appender pour le text area logger
 * @author Pierrick HYMBERT
 *
 */
public class ApplicationAppender extends WriterAppender {

	/**
	 * L'instance de l'application appender
	 */
	private static ApplicationAppender singleton = null;

	/**
	 * @return L'instance de l'application appender
	 */
	public static ApplicationAppender get() {
		return singleton;
	}

	private Text text = null;

	public ApplicationAppender() {
		singleton = this;
	}

	private class ApplicationOutputStream extends OutputStream {

		public void close() {
		}

		public void flush() {}

		public void write(byte b[]) throws IOException {
			insertText( new String(b) );
		}

		public void write(byte b[], int off, int len) throws IOException {
			insertText( new String(b, off, len) );
		}

		public void write(int b) throws IOException {
			insertText( new String(new char[]{(char)b}));
		}

		private void insertText(final String string) {
			getText().getDisplay().asyncExec( new Runnable() {
				
				public void run() {
					getText().insert(string);
				}
			});
		}
	}
	
	/**
	 * 
	 */
	public void activateOptions() {
		setWriter(createWriter(new ApplicationOutputStream()));
		super.activateOptions();
	}

	/**
	 * @return the text
	 */
	public Text getText() {
		return text;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(Text text) {
		this.text = text;
	}
}
